﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class EmailModify : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<int>(
                name: "EmailDelaySeconds",
                table: "TrialEmailNoticeConfig",
                type: "int",
                nullable: true,
                comment: "邮件延时秒数，比如一个事件触发，延迟多少s后才发邮件");

            migrationBuilder.AddColumn<int>(
                name: "EmailDelaySeconds",
                table: "EmailNoticeConfig",
                type: "int",
                nullable: true,
                comment: "邮件延时秒数，比如一个事件触发，延迟多少s后才发邮件");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "EmailDelaySeconds",
                table: "TrialEmailNoticeConfig");

            migrationBuilder.DropColumn(
                name: "EmailDelaySeconds",
                table: "EmailNoticeConfig");
        }
    }
}
