﻿using Org.BouncyCastle.Tls;
using System.Collections.Generic;

namespace IRaCIS.Core.API.OAuth;

public class LogtoUser
{
    public string Id { get; set; }
    public string Username { get; set; }
    public string PrimaryEmail { get; set; }
    public string PrimaryPhone { get; set; }
    public string Name { get; set; }
    public string Avatar { get; set; }
    public Dictionary<string, object> CustomData { get; set; } // Assuming customData can be any object
    public Dictionary<string, object> Identities { get; set; }

    public Dictionary<string, object> Profile { get; set; }
    public string ApplicationId { get; set; }
    public bool IsSuspended { get; set; }
    public bool HasPassword { get; set; }
}
