﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class init : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "ExportResult",
                table: "ReadingQuestionTrial");

            migrationBuilder.DropColumn(
                name: "ExportResult",
                table: "ReadingQuestionSystem");

            migrationBuilder.AddColumn<string>(
                name: "ExportResultStr",
                table: "ReadingQuestionTrial",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "[]",
                comment: "导出结果");

            migrationBuilder.AddColumn<string>(
                name: "ExportResultStr",
                table: "ReadingQuestionSystem",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "[]",
                comment: "导出结果");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "ExportResultStr",
                table: "ReadingQuestionTrial");

            migrationBuilder.DropColumn(
                name: "ExportResultStr",
                table: "ReadingQuestionSystem");

            migrationBuilder.AddColumn<int>(
                name: "ExportResult",
                table: "ReadingQuestionTrial",
                type: "int",
                nullable: true,
                comment: "导出结果");

            migrationBuilder.AddColumn<int>(
                name: "ExportResult",
                table: "ReadingQuestionSystem",
                type: "int",
                nullable: true,
                comment: "导出结果");
        }
    }
}
