﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class question1 : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<string>(
                name: "ClassifyAlgorithms",
                table: "ReadingTableQuestionSystem",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "",
                comment: "分类算法");

            migrationBuilder.AddColumn<Guid>(
                name: "ClassifyTableQuestionId",
                table: "ReadingTableQuestionSystem",
                type: "uniqueidentifier",
                nullable: true,
                comment: "分类问题表格Id");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "ClassifyAlgorithms",
                table: "ReadingTableQuestionSystem");

            migrationBuilder.DropColumn(
                name: "ClassifyTableQuestionId",
                table: "ReadingTableQuestionSystem");
        }
    }
}
