﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class doctorinfo10221319 : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<string>(
                name: "BankName",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "BankNum",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "BankPhoneNum",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "IdCard",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "OpeningBank",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "Summarize",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "SummarizeEn",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "BankName",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "BankNum",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "BankPhoneNum",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "IdCard",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "OpeningBank",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "Summarize",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "SummarizeEn",
                table: "Doctor");
        }
    }
}
