﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class doctorinfo10221525 : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<string>(
                name: "OtherCriterion",
                table: "TrialExperience",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "OtherStages",
                table: "TrialExperience",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "GCPAgencies",
                table: "Doctor",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<DateTime>(
                name: "GCPTime",
                table: "Doctor",
                type: "datetime2",
                nullable: true);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "OtherCriterion",
                table: "TrialExperience");

            migrationBuilder.DropColumn(
                name: "OtherStages",
                table: "TrialExperience");

            migrationBuilder.DropColumn(
                name: "GCPAgencies",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "GCPTime",
                table: "Doctor");
        }
    }
}
