﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class tablequestion10221643 : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<int>(
                name: "ExportIdentification",
                table: "ReadingTableQuestionTrial",
                type: "int",
                nullable: true,
                comment: "导出标识");

            migrationBuilder.AddColumn<string>(
                name: "ExportResultStr",
                table: "ReadingTableQuestionTrial",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "[]",
                comment: "导出结果");

            migrationBuilder.AddColumn<int>(
                name: "ExportIdentification",
                table: "ReadingTableQuestionSystem",
                type: "int",
                nullable: true,
                comment: "导出标识");

            migrationBuilder.AddColumn<string>(
                name: "ExportResultStr",
                table: "ReadingTableQuestionSystem",
                type: "nvarchar(400)",
                maxLength: 400,
                nullable: false,
                defaultValue: "[]",
                comment: "导出结果");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "ExportIdentification",
                table: "ReadingTableQuestionTrial");

            migrationBuilder.DropColumn(
                name: "ExportResultStr",
                table: "ReadingTableQuestionTrial");

            migrationBuilder.DropColumn(
                name: "ExportIdentification",
                table: "ReadingTableQuestionSystem");

            migrationBuilder.DropColumn(
                name: "ExportResultStr",
                table: "ReadingTableQuestionSystem");
        }
    }
}
