﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class doctorinfo10291357 : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<int>(
                name: "CriterionType",
                table: "TrialExperience",
                type: "int",
                nullable: true);

            migrationBuilder.AddColumn<int>(
                name: "ExperienceDataType",
                table: "TrialExperience",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "IndicationEnum",
                table: "TrialExperience",
                type: "int",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<Guid>(
                name: "TrialId",
                table: "TrialExperience",
                type: "uniqueidentifier",
                nullable: true);



            migrationBuilder.AddColumn<Guid>(
                name: "DoctorId",
                table: "Doctor",
                type: "uniqueidentifier",
                nullable: true);

            migrationBuilder.AddColumn<Guid>(
                name: "TrialId",
                table: "Doctor",
                type: "uniqueidentifier",
                nullable: true);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "CriterionType",
                table: "TrialExperience");

            migrationBuilder.DropColumn(
                name: "ExperienceDataType",
                table: "TrialExperience");

            migrationBuilder.DropColumn(
                name: "IndicationEnum",
                table: "TrialExperience");

            migrationBuilder.DropColumn(
                name: "TrialId",
                table: "TrialExperience");



            migrationBuilder.DropColumn(
                name: "DoctorId",
                table: "Doctor");

            migrationBuilder.DropColumn(
                name: "TrialId",
                table: "Doctor");
        }
    }
}
