﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace IRaCIS.Core.Infra.EFCore.Migrations
{
    /// <inheritdoc />
    public partial class IndicationTypeId : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<Guid>(
                name: "IndicationTypeId",
                table: "TrialExperience",
                type: "uniqueidentifier",
                nullable: false,
                defaultValue: new Guid("00000000-0000-0000-0000-000000000000"));

            migrationBuilder.CreateIndex(
                name: "IX_TrialExperience_TrialId",
                table: "TrialExperience",
                column: "TrialId");

            migrationBuilder.AddForeignKey(
                name: "FK_TrialExperience_Trial_TrialId",
                table: "TrialExperience",
                column: "TrialId",
                principalTable: "Trial",
                principalColumn: "Id");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_TrialExperience_Trial_TrialId",
                table: "TrialExperience");

            migrationBuilder.DropIndex(
                name: "IX_TrialExperience_TrialId",
                table: "TrialExperience");

            migrationBuilder.DropColumn(
                name: "IndicationTypeId",
                table: "TrialExperience");
        }
    }
}
